'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop(n) {
  return n;
};

var connect = function connect(Component) {
  var RefunkState = function (_React$Component) {
    _inherits(RefunkState, _React$Component);

    function RefunkState(props, context) {
      _classCallCheck(this, RefunkState);

      var _this = _possibleConstructorReturn(this, (RefunkState.__proto__ || Object.getPrototypeOf(RefunkState)).call(this));

      _this.child = isChild(context);

      _this.state = _this.child ? null : _extends({}, props);

      _this.functionalUpdate = function (fn, cb) {
        var _this$props$mapState = _this.props.mapState,
            mapState = _this$props$mapState === undefined ? noop : _this$props$mapState;

        var mapped = mapState(_this.state);
        var next = typeof fn === 'function' ? fn(mapped) : fn;
        _this.setState(next, cb);
      };

      _this.update = _this.child ? context.update : _this.functionalUpdate;
      return _this;
    }

    _createClass(RefunkState, [{
      key: 'getChildContext',
      value: function getChildContext() {
        var _props$mapState = this.props.mapState,
            mapState = _props$mapState === undefined ? noop : _props$mapState;

        return this.child ? this.context : {
          state: mapState(this.state),
          update: this.update
        };
      }
    }, {
      key: 'render',
      value: function render() {
        var _props$mapState2 = this.props.mapState,
            mapState = _props$mapState2 === undefined ? noop : _props$mapState2;

        var state = this.child ? this.context.state : this.state;
        var props = mapState(state);

        return _react2.default.createElement(Component, _extends({}, this.props, props, {
          update: this.update
        }));
      }
    }]);

    return RefunkState;
  }(_react2.default.Component);

  RefunkState.childContextTypes = {
    state: _propTypes2.default.object,
    update: _propTypes2.default.func
  };
  RefunkState.contextTypes = {
    state: _propTypes2.default.object,
    update: _propTypes2.default.func
  };
  RefunkState.propTypes = {
    mapState: _propTypes2.default.func
  };
  RefunkState.defaultProps = {
    mapState: noop
  };


  return RefunkState;
};

var isChild = function isChild(context) {
  return _typeof(context.state) === 'object' && typeof context.update === 'function';
};

exports.default = connect;
module.exports = exports['default'];